// code by jph

class aniApache : public aniMated {
public:
  aniApache(void);
  void scene(void);
  void interact(aniWave* wav);
  char* toString(void) { return "aniApache"; };
  aniAppend app_rot;
  aniAppend app_sid;
  tensor<double> lev_rot;
  tensor<double> lev_sid;
  control<double> ctr_rot;
  control<double> ste;
  audio eng;  
  time fir;
  int cnt;
  int operate;
  static double vn;
};

double aniApache::vn=2e1;

aniApache::aniApache(void) : 
  eng("get/audio/heli.wav",FMOD_LOOP_NORMAL|FMOD_3D) {
  operate=1;
  msh=opengl_meshgl("get/mesh/helicopter");
  shd=new shadow(msh);
  rap=new rapid(msh);
  setMassByVolume(0.2);
  
  lev_rot=tensor<double>::vector(4).as( 0.0, 0.0, 2.9, 1.0);
  lev_sid=tensor<double>::vector(4).as(-8.0, 0.3, 0.72, 1.0);
  
  app_rot.mas=this;
  app_rot.slv=new aniMated();
  app_rot.slv->msh=opengl_meshgl("get/mesh/helicopter_mainrotor");
  app_rot.slv->shd=new shadow(app_rot.slv->msh);
  aniWorld::singleton()->link(&app_rot);
  aniWorld::singleton()->add(app_rot.slv);
  
  app_sid.mas=this;
  app_sid.slv=new aniMated();
  app_sid.slv->msh=new meshgl(*opengl_meshgl("get/mesh/boat_rotor"));
  tensor<double> map=glExp(tensor<double>::vector(4).as( MATH_PI_2, 0.0, 0.0, 0.0));
  *app_sid.slv->msh=app_sid.slv->msh->map(map);
  app_sid.slv->shd=new shadow(app_sid.slv->msh);
  aniWorld::singleton()->link(&app_sid);
  aniWorld::singleton()->add(app_sid.slv);

  ctr_rot.vn=1;
  ste.vn=1;
  cnt=0;
  fot=1;
  fva=1;
  status|=ANI_MOTION;
}

void aniApache::scene(void) {
  int hum=this==aniMated::humanized;  
  if (keyboard_down('h'))
    pos.in(0,glExp(tensor<double>::randn(1,3)).data,12);  
  // stabilization
  tensor<double> mtc=tensor<double>::vector(4).as( 0.0, 0.0, 10.0, 0.0);
  time tim=opengl_time;
  mtc(0)=perlin( tim.s());
  mtc(1)=perlin(-tim.s());
  mtc=mtc.normal();
  tor+=pos.solve(glMatchVectorsD(pos[2],mtc))*2-ome;
  tor*=operate;
  
  tensor<double> tar(1,4);
  tar(2)=1;
  if (hum) {
    tar(0)=keyboard(KEY_AU)-keyboard(KEY_AD);
    tar(1)=keyboard(KEY_AL)-keyboard(KEY_AR);    
    tar=tar.normal(); // compensate drop using tar(2) holds information
    tor+=glMatchVectorsD(tensor<double>::eye(4)[2],tar);
    
    if (keyboard_down(' ') && 0.7<pos(2,2) && fir<tim) {      
      aniArmory* arm=new aniArmory();
      arm->pos=pos*glT(0,(cnt++%2?-1:1)*0.9,-2.3);
      arm->vel=vel;
      arm->msh=opengl_meshgl("get/mesh/bomb");
      arm->shd=new shadow(arm->msh);
      arm->rap=new rapid(arm->msh);
      arm->rap->pos=arm->pos;
      arm->ine=arm->msh->inertia();
      arm->setMassByVolume(0.5);
      arm->grv=aniMated::gravity;
      arm->rmv=tim+30;
      aniWorld::singleton()->add(arm);
      fir=tim+1;
      
      audio* aud=new audio("get/audio/drop.wav",FMOD_3D);
      aud->pos=arm->pos[3];
      aud->vol=1;
      aud->play();
      audio::mixer.add(aud);
    }
  }
  
  control<double>::dt=opengl_rate.s(); // TODO find better solution !?!?!
  ctr_rot.cn=1+(1-tar(2))*0.285+(keyboard(KEY_PU)-keyboard(KEY_PD))*hum*0.5;
  ste.cn=1+(keyboard(KEY_AL)-keyboard(KEY_AR))*hum*0.5;
  //ste.cn=0.98+(keyboard(KEY_AL)-keyboard(KEY_AR))*hum*0.5;
  
  operate&=0.1<pos(2,2);
  
  ctr_rot.cn*=operate;
  ste.cn*=operate;
  
  ctr_rot.EXACT_integrate();
  ste.EXACT_integrate();
  eng.doppler(ctr_rot.vn);
  eng.pos=pos*lev_rot;
  eng.vel=vel;
  eng.play();
  
  double grv=-9.81;
  acc(2)-=grv*ctr_rot.vn;
  tensor<double> top=tensor<double>(1,4).as( 0.0, 0.0, 1.0, 0.0);
  acc+=glI(pos)*top*grv; // TODO this should be done by some friction trick!
  tor(2)+=operate*(ste.vn-1)*3;
  
  app_rot.trf=glT(lev_rot)*glExp(tensor<double>::vector(4).as( 0.0, 0.0, ctr_rot.pn*aniApache::vn, 1.0));
  app_sid.trf=glT(lev_sid)*glExp(tensor<double>::vector(4).as( 0.0, ste.pn*aniApache::vn, 0.0, 1.0));
  // TODO bos.pn mod 2pi  
  //opengl_label_add(pos[3],tensor<double>::string( pos(2,3) ));   
}

void aniApache::interact(aniWave* wav) {
  tensor<double> smp(2,4,2);
  smp(0,0)=9+random<double>::normal();
  smp(1,0)=  random<double>::normal();
  smp(3,0)=1;
  
  smp(0,0)=  random<double>::normal();
  smp(1,1)=9+random<double>::normal();
  smp(3,1)=1;
  tensor<double> pnt=pos*app_rot.trf*smp;
  for (int c0=0;c0<smp.size[1];++c0)
    if (pnt(2,c0)<20) {
      int tmp=++wav->dsr;
      tmp%=wav->num;
      // TODO particle gen does not depend on ani::dt, but should probably
      wav->let[tmp].particle(pnt[c0],(c0%2?1:-1)*sqrt(20-pnt(2,c0))*0.85);
      //wav->let[tmp].particle(pnt[c0],(random<double>::normal()<0?1:-1)*(10-pnt(2,c0))*0.5); // TODO
      
    }
}
