// code by jph

class aniArmory : public aniMated {
public:
  aniArmory(void);
  void scene(void);
  char* toString(void) { return "aniArmory"; };
  time rmv;
  double grv;
  static void shot(tensor<double> pos,double vel);
};

aniArmory::aniArmory(void) {
  fva=0.1;
  status|=ANI_MOTION;
  grv=0; // aniMated::gravity; don't activate grav until better aming
}

void aniArmory::scene(void) {
  
  acc-=glI(pos)[2]*grv;//aniMated::gravity;
  if (rmv<opengl_time || collision)
    status|=ANI_DELETE;
  if (collision) {
    aniFireball* frb=new aniFireball();
    frb->rmv=opengl_time+1;
    frb->pos=pos;
    aniWorld::singleton()->add(frb);
  }
}

void aniArmory::shot(tensor<double> pos,double vel) {
  audio* aud=new audio("get/audio/turret_shot.wav",FMOD_3D);
  aud->pos=pos[3];
  aud->vol=1;
  aud->play();
  audio::mixer.add(aud);  
  
  aniArmory* arm=new aniArmory();
  arm->pos=pos;
  arm->vel=pos[0]*vel;
  arm->msh=opengl_meshgl("get/mesh/turret_bullet");
  arm->ine=arm->msh->inertia();
  arm->shd=new shadow(arm->msh);
  arm->rap=new rapid(arm->msh);
  arm->rap->pos=arm->pos;
  arm->setMassByVolume(10);
  arm->rmv=opengl_time+2.0;
  aniWorld::singleton()->add(arm);
}
