
class aniCamera : public aniMated {
public:
  aniCamera(void);
  void focus(aniMated *ani,tensor<double> lev);
  void scene(void);
  void draw(void);
  tensor<double> opengl();
  char* toString(void) { return "aniCamera"; };
  aniMated *ani;
  tensor<double> lev;
  tensor<double> lok;
  
  tensor<double> tmp; // 4x4 used for 
};

aniCamera::aniCamera(void) {
  msh=opengl_meshgl("get/mesh/videocam_84_cnv"); // sphere_56_v
  shd=new shadow(msh);
  rap=new rapid(opengl_meshgl("get/mesh/sphere_56_v"));

  //msh=new meshgl(*opengl_meshgl("get/mesh/sphere_224_tnv"));
  //msh=new meshgl(*opengl_meshgl("get/mesh/sphere_224_tnv"));
  
  lev=tensor<double>(1,4);
  lok=tensor<double>(1,4);
  status|=ANI_MOTION;
};

void aniCamera::focus(aniMated *ani_,tensor<double> lev_) {
  ani=ani_;
  lev=lev_;
  lev(3)=1;
  lok(0)=10;
  lok(3)=1;
//  pos=ani->pos;
//  pos.in(12,pos*lev);
  pos=glLookAtX(ani->pos*lev,ani->pos*lok);
  tmp=pos;
  //pos=glLookAt(pos*lev,ani->pos[3]);
}

tensor<double> aniCamera::opengl(void) {
  tensor<double> ret=tmp;
  ret(0,0)=-tmp(0,1);
  ret(1,0)=-tmp(1,1);
  ret(2,0)=-tmp(2,1);
  ret(0,1)= tmp(0,2);
  ret(1,1)= tmp(1,2);
  ret(2,1)= tmp(2,2);
  ret(0,2)=-tmp(0,0);
  ret(1,2)=-tmp(1,0);
  ret(2,2)=-tmp(2,0);
  return glI(ret);
}

void aniCamera::scene(void) {
  if (!ani) {
    printf("camera!");
    return;
  }
  tensor<double> rot=glLookAtX(pos[3],ani->pos*lok);
  
  tensor<double> des=pos.solve(pos[3]-ani->pos*lev);
  acc-=des+pos.solve(vel);
  
  tensor<double> res=pos.solve(rot);
  res(0,3)=0;
  res(1,3)=0;
  res(2,3)=0;
  
  res=res.log();
  //printf("%s\n\n",res.toString());
  
  tensor<double> trq(1,4);
  trq(0)=res(2,1);
  trq(1)=res(0,2);
  trq(2)=res(1,0);
  
  tor=(trq*1.2-ome)*2;
  if (3<tor.norm()) {
    tor=0;  
    ome=0;
    pos.in(0,rot.data,12);
  }
  tmp=pos;
  
  //tensor<double> mat=ani->pos;
  //mat(2,0)=mat(2,1)=0;
  //mat=glOrthogonalize(mat);
  //pos.in(0,mat.data,12);
  //
  //tensor<double> cur=pos[3];
  //tensor<double> dst=mat*lev;
  //
  ////pos=glLookAtX(cu,cur);
  //
  //double lam=opengl_slider("control pos",0.5);
  //double tau=opengl_slider("control vel",0.5);
  //acc=pos.solve( (dst-cur)*lam - vel*tau );
  
  opengl_bulletin.add(tensor<char>::string("camera on ")&tensor<char>::string( ani->toString() ));
}

void aniCamera::draw() {
  //printf("asdf\n");
  if (msh)
    msh->draw();
  if (0) {
    glPushAttrib(GL_ENABLE_BIT);
      glEnable(GL_BLEND);
      glColor4d( 0.5,0,0,0.2);
      glBegin(GL_TRIANGLE_FAN);
        glVertex3d(0,0,0);
        glVertex3d(100,-50, 50);
        glVertex3d(100, 50, 50);
        glVertex3d(100, 50,-50);
        glVertex3d(100,-50,-50);
        glVertex3d(100,-50, 50);
      glEnd();
    glPopAttrib();
  }
}

