// code by jph

class aniCatamaran : public aniMated {
public:
  aniCatamaran();
  void scene(void);
  char* toString(void) { return "aniCatamaran"; };

  control<double> bos;
  control<double> ste;
  tensor<double>  lev[2];
  aniAppend       app_rot[2];
  aniMated*       fan;
  audio eng;
  audio wav;
  double sub;
};

aniCatamaran::aniCatamaran() :
  eng("get/audio/boat.wav",FMOD_LOOP_NORMAL|FMOD_3D),
  wav("get/audio/aqua.wav",FMOD_LOOP_NORMAL|FMOD_3D) {
  msh=opengl_meshgl("get/mesh/catamaran"); //long_72_cnv
  double vol;
  //tensor<double> ctr=msh->centroid(vol);
  //printf("%s\n",ctr.toString());
  //*msh=msh->map(glT(ctr*-1));  
  shd=new shadow(msh);
  ine=msh->inertia();
  rap=new rapid(msh);
  setMassByVolume(0.3);
  status|=ANI_MOTION;
  fva=0.1;
  fot=0.1;

  //printf("INERTIA\n%s\n",ine.toString());

  bos.MU=0.5;
  sub=0;

  meshgl* pro=opengl_meshgl("get/mesh/bpro");
  tensor<double> map=tensor<double>::eye(4);
  map(0,0)=map(1,1)=map(2,2)=0.5;
  *pro=pro->map(map);    
  for (int c0=0;c0<2;++c0) {
    lev[c0]=tensor<double>::vector(4).as(-3.1, c0?-1.4:1.4,-0.4, 1.0);
    app_rot[c0].mas=this;
    app_rot[c0].slv=new aniMated();
    app_rot[c0].slv->msh=pro;
    
    app_rot[c0].slv->shd=new shadow(app_rot[c0].slv->msh);
    aniWorld::singleton()->link(&app_rot[c0]);
    aniWorld::singleton()->add(app_rot[c0].slv);
  }
  //shader=opengl_shader_cl("get/shader/CH06-brick");
  //opengl_shader_use(shader);
  //opengl_shader_uniform("BrickColor",tensor<double>::vector(3).as(1.0,0.3,0.2));
  //opengl_shader_uniform("MortarColor",tensor<double>::vector(3).as(0.85,0.86,0.84));
  //opengl_shader_uniform("BrickSize",tensor<double>::vector(2).as(0.60,0.45));
  //opengl_shader_uniform("BrickPct",tensor<double>::vector(2).as(0.90,0.85));
  //opengl_shader_use(0);  
  
}

void aniCatamaran::scene(void) {  
  if (keyboard_down('r')) {
    pos(2,3)=7;
    rap->pos=pos;
  }
  acc-=glI(pos)[2]*aniMated::gravity;
  int hum=this==aniMated::humanized;  
  bos.cn=(keyboard(KEY_AU)-keyboard(KEY_AD))*hum*(2-(sub<0));
  ste.cn=(keyboard(KEY_AR)-keyboard(KEY_AL))*hum;
  control<double>::dt=opengl_rate.s();
  bos.EXACT_integrate();
  ste.EXACT_integrate();
  //if (sub<0) {
  for (int c0=0;c0<2;++c0) {
    tensor<double> frc=tensor<double>::vector(4).as(
      cos(ste.vn), sin(ste.vn),0.0, 0.0);
    frc*=bos.vn*6;
    acc+=frc;
    tor+=lev[c0].x(frc); // TODO
  }
  eng.vol=0.5+0.3*abs(bos.vn);
  double bla=(vel+pos*ome.x(lev[0])).norm()*0.1; // TODO
  eng.doppler(1+abs(bos.vn)*bla);
  eng.pos=pos*lev[0]; // TODO
  eng.vel=vel;
  eng.play();
  
  wav.vol=min(vel.norm()*0.1*(sub<0),1);
  wav.pos=pos[3];
  wav.play();
  //app_rot.trf=glT(lev)*glExp(tensor<double>::vector(4).as( bos.pn*10, 0.0, 0.0, 0.0));
  for (int c0=0;c0<2;++c0)
    app_rot[c0].trf=glT(lev[c0])*glExp(tensor<double>::vector(4).as( 0.0, 0.0, ste.vn, 0.0))*glExp(tensor<double>::vector(4).as( bos.pn*10, 0.0, 0.0, 0.0));  
}
