// code by jph

class aniFireball : public aniMated {
public:
  aniFireball();
  ~aniFireball();
  void scene(void);
  char* toString(void) { return "aniFireball"; };
  time tim;
  time rmv;
  
static meshgl* sph;
};

aniFireball::aniFireball() {
  if (!sph)
    sph=opengl_meshgl("get/mesh/sphere_224_tcnv");
  tensor<double> map=tensor<double>::eye(4);
  msh=new meshgl(sph->map(map));
  status|=ANI_MOTION|ANI_BLEND;  
  tim=opengl_time;
}

aniFireball::~aniFireball() {
  delete msh;
}

void aniFireball::scene(void) {  
  if (rmv<opengl_time)
    status|=ANI_DELETE;
  vel=0;
  int v3f=msh->offsetV3F();
  int c3f=msh->offsetC3F();
  double elp=(opengl_time-tim).s();
  double nse=opengl_time.s();
  for (int c0=0;c0<msh->arr.size[1];++c0) {
    tensor<double> vec=sph->vector(c0);
    vec*=sqrt(elp)*(2+2*perlin(vec.data[0]+6,vec.data[1],vec.data[2],nse));
    msh->arr(v3f+0,c0)=vec.data[0];
    msh->arr(v3f+1,c0)=vec.data[1];
    msh->arr(v3f+2,c0)=vec.data[2];
    msh->arr(c3f+0,c0)=                          (perlin(vec.data[0]+0,vec.data[1],vec.data[2],nse)*0.5+0.5)*max(0,1-elp);
    msh->arr(c3f+1,c0)=min(msh->arr(c3f+0,c0),abs(perlin(vec.data[0]+2,vec.data[1],vec.data[2],nse)        )*max(0,1-elp));
    msh->arr(c3f+2,c0)=0;
    msh->arr(c3f+3,c0)=max(0,1-elp);
  }
  msh->updateN3F();
}

meshgl* aniFireball::sph=0;