// code by jph

// TODO specify in what heights to grow
// test star shape vs. cesar seat shape
class aniGrass {
public:
  aniGrass(double wid,double hgt,tensor<double> crd) {
    this->wid=wid;
    this->hgt=hgt;
    t0_=crd(0);
    t1_=crd(1);
    t_0=crd(2);
    t_1=crd(3);
  }
  double wid,hgt;
  double t0_,t1_,t_0,t_1;
};

class aniGrasslet {
public:
  aniGrasslet(aniGrass* typ,tensor<double> pnt) {
    this->typ=typ;
    this->pnt=pnt;
  }
  aniGrass* typ;
  tensor<double> pnt; // vector(4) location
};

class aniTree {
public:
  aniTree(char* str,double wid,double ini) {
    tex=opengl_texture(str);
    this->wid=wid;
    this->ini=ini;
  }
  uint tex;
  double wid;
  double ini;
  double prb;
};

class aniTreelet : public aniMated {
public:
  aniTreelet() {}
  aniTreelet(aniTree* tre,tensor<double> tri,double hgt);
  
  aniTree* tre;
  double hgt;
  aniTreelet* bnc[3];
  
  static aniTreelet* fin;
};

aniTreelet* aniTreelet::fin=new aniTreelet();

#define ANI_TREETEXTURE_FAC  0.2

aniTreelet::aniTreelet(aniTree* tre,tensor<double> tri,double hgt) {
  this->tre=tre;
  this->hgt=hgt;
  bnc[0]=bnc[1]=bnc[2]=0;
  
  assert(tri.size[0]==4 && tri.size[1]==3);
  tri(3,0)=tri(3,1)=tri(3,2)=1;
  pos=glMatrixFromVector((tri[1]-tri[0]).x(tri[2]-tri[0]),tri.mean());
  double cum=(tri[1]-tri[0]).norm()+(tri[2]-tri[1]).norm()+(tri[0]-tri[2]).norm();
  //printf("%s\n\n",pos.toString());
  tri=glI(pos)*tri;
  tensor<float> smp=tri.to<float>();
  msh=new meshgl();
  msh->texture=tre->tex;
  msh->format=GL_T2F_N3F_V3F;
  msh->arr=tensor<float>(2,8,7);
  // BEGIN: texture
  // TODO for loop needs to match integer!!!
  msh->arr.data[0+8*0]=0;
  msh->arr.data[0+8*1]=MATH_1_3  ;//*cum*ANI_TREETEXTURE_FAC;
  msh->arr.data[0+8*2]=MATH_1_3*2;//*cum*ANI_TREETEXTURE_FAC;
  msh->arr.data[1+8*0]=0;
  msh->arr.data[1+8*1]=0;
  msh->arr.data[1+8*2]=0;  
  msh->arr.data[0+8*3]=0;
  msh->arr.data[0+8*4]=MATH_1_3  ;//*cum*ANI_TREETEXTURE_FAC;  
  msh->arr.data[0+8*5]=MATH_1_3*2;//*cum*ANI_TREETEXTURE_FAC;
  msh->arr.data[1+8*3]=hgt*ANI_TREETEXTURE_FAC;
  msh->arr.data[1+8*4]=hgt*ANI_TREETEXTURE_FAC;
  msh->arr.data[1+8*5]=hgt*ANI_TREETEXTURE_FAC;
  // END: texture  
  
  // BEGIN: vertices
  smp(2,0)=smp(2,1)=smp(2,2)=0.05;
  msh->arr.in(5+8*0,smp^0,3);
  msh->arr.in(5+8*1,smp^4,3);
  msh->arr.in(5+8*2,smp^8,3);
  
  tensor<float> rot=glExp(tensor<double>::randn(1,4)*0.1).to<float>();
  smp=rot*smp;
  smp*=0.8;
  smp(2,0)=smp(2,1)=smp(2,2)=hgt;
  msh->arr.in(5+8*3,smp^0,3);
  msh->arr.in(5+8*4,smp^4,3);
  msh->arr.in(5+8*5,smp^8,3);
  
  tensor<float> tmp=rot[2]; // TODO
  tmp*=cum*MATH_1_3*0.816497; // sqrt(2/3)
  
  tmp(2)+=hgt;
    
  msh->arr.in(5+8*6,tmp^0,3);
  
  // END: vertices
  
  // BEGIN: topology
  msh->ind[MESH_TRIA]=tensor<int>(2,3,4).as(    
    3,4,6,
    4,5,6,
    5,3,6,
    0,2,1);
  msh->ind[MESH_QUAD]=tensor<int>(2,4,3).as(
    0,1,4,3,
    1,2,5,4,
    2,0,3,5);
  // END: topology
  msh->updateN3F();  
  shd=new shadow(msh);
  rap=new rapid(msh);  
}

class aniForest : public aniMated {
public:
  aniForest(meshgl* gnd);
  void trees(tensor<float> hgt,int num);
  tensor<double> roo; // locations of trees
  void grass(char* str);
  void grass(tensor<float> hgt,int fac);
  void grass(void); // draws grass
  char* toString(void) { return "aniForest"; };
  linked<aniTreelet*> lst[5];
  tensor<aniTree*>    tre;
  int numel;
  
  tensor<aniGrass*> grs;
  tensor<aniGrasslet*> glt; // locations of grass and type
  tensor<double> bsh;       // locations of grass
  uint grass_tex;
};

aniForest::aniForest(meshgl* gnd) {
  ine*=1e100;
  msh=gnd;
  rap=new rapid(gnd);
  tre=tensor<aniTree*>(1,0);
  numel=0;
}

void aniForest::trees(tensor<float> hgt,int num) {
  tensor<float> hgx=hgt.gradient(0);
  tensor<float> hgy=hgt.gradient(1);
  blue<double> blu(tensor<int>::vector(2).as((hgt.size[0]-1)*2,(hgt.size[1]-1)*2),3*sqrt(2.0));
  //blue<double> blu(tensor<int>::vector(2).as((hgt.size[0]-1)*12,(hgt.size[1]-1)*12),0.5*sqrt(2.0));
  blu.complete(6); // grow some trees
  tensor<double> pnt(1,2);
  tensor<double> itp(1,2);
  tensor<double> ins(1,4);
  tensor<int> idx;
  tensor<double> ext=blu.extension();
  // TODO tokenizer for blue
  tensor<int> prm=tensor_randperm(blu.point.numel);
  aniTreelet* let;
  for (int c0=0;c0<blu.point.numel && numel<num;++c0) {
    int chk=blu.point.get(prm(c0)+1,pnt);
    assert(chk);
    itp(0)=pnt(0)/ext(0);
    itp(1)=pnt(1)/ext(1);
    double hmy=hgt.interp(itp);
    double hdx=hgx.interp(itp);
    double hdy=hgy.interp(itp);
    if (3<hmy) {
      ins(0)=pnt(0);
      ins(1)=pnt(1);
      ins(2)=hmy;
      ins(3)=1;
      aniTree* typ=tre((int)(random<double>::uniform()*tre.numel)); // type
      tensor<double> vdx=tensor<double>::vector(3).as( 6.0, 0.0, hdx);
      tensor<double> vdy=tensor<double>::vector(3).as( 0.0, 6.0, hdy);
      tensor<double> frm=glMatrixFromVector(vdx.x(vdy).normal(),ins);      
      double srt=0.866025;
      double fac=typ->wid;
      tensor<double> loc=tensor<double>::matrix(4,3).as(
         1.0*fac, 0.0*fac, 0.0, 1.0,
        -0.5*fac, srt*fac, 0.0, 1.0,
        -0.5*fac,-srt*fac, 0.0, 1.0       
        );
      tensor<double> tri=frm*loc;
      double mrk=2;
      if (mrk<tri.data[2] && mrk<tri.data[2+4] && mrk<tri.data[2+8]) {
        let=new aniTreelet(typ,tri,typ->ini);        
        lst[0].add(let);
        aniWorld::singleton()->add(let);
        ++numel;
      }
    }
  }
  for (int c1=0;c1<3;++c1)
    if (lst[c1].numel) {
      while (lst[c1].token(let)) {
        tensor<int> prm;
        tensor<double>::rand(1,3).sort(TENSOR_SORT_ABC,prm);
        //printf("%s\n",prm.toString());
        for (int c2=0;c2<3;++c2) {
          int c0=prm(c2);
          if (!let->bnc[c0] && let->bnc[c0]!=aniTreelet::fin) {
            if (random<float>::uniform()<0.9/(c1+1)) {
              tensor<int> ind=let->msh->ind[MESH_TRIA][c0];
              int ofs=5;
              tensor<double> tri=let->msh->arr(tensor<int>(1,4).as(ofs+0,ofs+1,ofs+2,ofs+2),ind).to<double>();
              tri(3,0)=tri(3,1)=tri(3,2)=1;
              let->bnc[c0]=new aniTreelet(let->tre,let->pos*tri,let->hgt*0.8);            
              if (!aniWorld::singleton()->intrudes(let->bnc[c0])) {
                lst[c1+1].add(let->bnc[c0]);
                aniWorld::singleton()->add(let->bnc[c0]);
              } else {
                delete let->bnc[c0];
                let->bnc[c0]=aniTreelet::fin;
              }            
            } else
              let->bnc[c0]=aniTreelet::fin;    
          }
        }        
        int cnt=0;
        for (int c0=0;c0<3;++c0)
          cnt+= !let->bnc[c0] && let->bnc[c0]!=aniTreelet::fin;
        if (!cnt)
          lst[c1].remove();
      }
    }
}

void aniForest::grass(char* str) { 
  grass_tex=opengl_texture(str);
  grs=tensor<aniGrass*>(1,0);
}

void aniForest::grass(tensor<float> hgt,int fac) {
  assert(grs.numel);
  tensor<float> hgx=hgt.gradient(0);
  tensor<float> hgy=hgt.gradient(1);
  //int fac=6;
  blue<double> blu(tensor<int>::vector(2).as((hgt.size[0]-1)*fac,(hgt.size[1]-1)*fac),sqrt(2.0)*6/fac);
  blu.complete(4); // grow some grass
  linked<aniGrasslet*>    glt_lnk;
  linked<tensor<double>>  bsh_lnk;
  tensor<double> pnt(1,2);
  tensor<double> itp(1,2);
  tensor<double> ins(1,4);
  tensor<double> ext=blu.extension();
  for (int c0=1;c0<=blu.point.numel;++c0) {
    int chk=blu.point.get(c0,pnt);
    assert(chk);
    itp(0)=pnt(0)/ext(0);
    itp(1)=pnt(1)/ext(1);
    double hmy=hgt.interp(itp);
    double hdx=hgx.interp(itp);
    double hdy=hgy.interp(itp);
    tensor<double> vdx=tensor<double>::vector(3).as( 6.0, 0.0, hdx);
    tensor<double> vdy=tensor<double>::vector(3).as( 0.0, 6.0, hdy);
    if (3+random<double>::uniform()*2<hmy && 0.8<vdx.x(vdy).normal().data[2]) {
      ins(0)=pnt(0);
      ins(1)=pnt(1);
      ins(2)=hmy;
      ins(3)=1;
      glt_lnk.add(new aniGrasslet(grs((int)(random<double>::uniform()*grs.numel)),ins));
      bsh_lnk.add(ins);
    }
  }
  glt=glt_lnk.toTensor();
  bsh=bsh_lnk.toTensor(4);
}

void aniForest::grass(void) { // TODO merge with all other transparent  
  if (!bsh.numel)
    return;
  //opengl_bulletin.add(tensor<char>::string("grass ")&tensor<int>::string( glt.numel ));
  // BEGIN: grass render
  glPushAttrib(GL_ENABLE_BIT);
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);  
    glDisable(GL_CULL_FACE);
    glActiveTexture(GL_TEXTURE0);
    glBindTexture(GL_TEXTURE_2D,grass_tex); // bsh    
    tensor<double> res=opengl_project*opengl_camera*pos*bsh;
    linked<int> rem;
    linked<double> dpt;
    double lim=120;
    for (int c0=0;c0<res.size[1];++c0)
      if (0.1<res(2,c0) && res(2,c0)<lim) 
        if ((abs(res(0,c0))-5)/res(3,c0)<1 && 
            (abs(res(1,c0))-5)/res(3,c0)<1) { // TODO anything more elegant !?
          rem.add(c0);
          dpt.add(res(2,c0));
        }
    tensor<int> ind=rem.toTensor();
    tensor<int> pri;
    tensor<double> dep=dpt.toTensor().sort(TENSOR_SORT_CBA,pri);
    aniGrass* typ;    
    glPushMatrix();
    glMultMatrixd(pos.data);
    glBegin(GL_QUADS); 
      tensor<double> pnt;
      tensor<double> pnd;
      double ddx,ddy;
      int c0;
      double tim=opengl_time.s()*0.2;
      for (int c1=0;c1<ind.numel;++c1) {
        glColor4d(1.0,1.0,1.0,1-dep(c1)/lim);
        c0=ind(pri(c1));
        pnt=bsh[c0];
        pnd=pnt;
        pnd(0)+=perlin(pnt(0)*0.03,pnt(1)*0.03,tim,0)*0.5;
        pnd(1)+=perlin(pnt(0)*0.03,pnt(1)*0.03,tim,1)*0.5;
        typ=grs(c0%3%grs.numel);
        ddx=cos(c0+0.0)*typ->wid;
        ddy=sin(c0+0.0)*typ->wid;
        glTexCoord2d(typ->t0_,typ->t_0); glVertex3d(pnt(0)-ddx,pnt(1)+ddy,pnt(2));
        glTexCoord2d(typ->t1_,typ->t_0); glVertex3d(pnt(0)+ddx,pnt(1)-ddy,pnt(2));
        glTexCoord2d(typ->t1_,typ->t_1); glVertex3d(pnd(0)+ddx,pnd(1)-ddy,pnt(2)+typ->hgt);
        glTexCoord2d(typ->t0_,typ->t_1); glVertex3d(pnd(0)-ddx,pnd(1)+ddy,pnt(2)+typ->hgt);
        ddx=cos(c0+MATH_PI*2/3)*typ->wid;
        ddy=sin(c0+MATH_PI*2/3)*typ->wid;
        glTexCoord2d(typ->t0_,typ->t_0); glVertex3d(pnt(0)-ddx,pnt(1)+ddy,pnt(2));
        glTexCoord2d(typ->t1_,typ->t_0); glVertex3d(pnt(0)+ddx,pnt(1)-ddy,pnt(2));
        glTexCoord2d(typ->t1_,typ->t_1); glVertex3d(pnd(0)+ddx,pnd(1)-ddy,pnt(2)+typ->hgt);
        glTexCoord2d(typ->t0_,typ->t_1); glVertex3d(pnd(0)-ddx,pnd(1)+ddy,pnt(2)+typ->hgt);
        ddx=cos(c0+MATH_PI*4/3)*typ->wid;
        ddy=sin(c0+MATH_PI*4/3)*typ->wid;
        glTexCoord2d(typ->t0_,typ->t_0); glVertex3d(pnt(0)-ddx,pnt(1)+ddy,pnt(2));
        glTexCoord2d(typ->t1_,typ->t_0); glVertex3d(pnt(0)+ddx,pnt(1)-ddy,pnt(2));
        glTexCoord2d(typ->t1_,typ->t_1); glVertex3d(pnd(0)+ddx,pnd(1)-ddy,pnt(2)+typ->hgt);
        glTexCoord2d(typ->t0_,typ->t_1); glVertex3d(pnd(0)-ddx,pnd(1)+ddy,pnt(2)+typ->hgt);
      }
    glEnd();
    glPopMatrix();
    glDisable(GL_TEXTURE_2D);
  glPopAttrib();
  // END: grass render
}

