// code by jph

class aniHornet : public aniMated {
public:
  aniHornet(void);
  void scene(void);
  void hover(aniMated* ani);
  void interact(aniWave* wav);
  char* toString(void) { return "aniHornet"; };
  aniAppend app_bst[2];
  tensor<double> lev_bst[2];
  tensor<double> dsp_bst[2];
  control<double> ctr_bst[2];
  control<double> ctr_upd[2];
  control<double> ctr_fir;
  
  //control<double> ctr_rot;
  //control<double> ste;
  double cum[2];
  int wav_cnt[2];
  meshgl* hul_msh;
  rapid* hul_rap;
  audio eng;  
  time fir;
  int cnt;
  static double vn;
};

double aniHornet::vn=2e1;

aniHornet::aniHornet(void) : 
  eng("get/audio/heli.wav",FMOD_LOOP_NORMAL|FMOD_3D) {
  msh=opengl_meshgl("get/mesh/hornet");
  shd=new shadow(msh);
  rap=new rapid(msh);
  hul_msh=opengl_meshgl("get/mesh/ellipse_224_tnv");
  hul_rap=new rapid(hul_msh);
  //ine=msh->inertia();
  //lev_bst[1]=tensor<double>::vector(4).as(-1.3,-3.65, 1.2, 1.0 );
  
  for (int c0=0;c0<2;++c0) {
    dsp_bst[c0]=tensor<double>::vector(4).as(-1.3, 3.45*(c0?-1:1), 1.12, 1.0 );
    lev_bst[c0]=tensor<double>::vector(4).as( 0.0, 3.65*(c0?1:-1),-0.2, 1.0 );
    app_bst[c0].mas=this;
    app_bst[c0].slv=new aniMated();
    app_bst[c0].slv->msh=opengl_meshgl("get/mesh/hornetprop");
    app_bst[c0].slv->shd=new shadow(app_bst[c0].slv->msh);
    aniWorld::singleton()->link(&app_bst[c0]);
    aniWorld::singleton()->add(app_bst[c0].slv);
  }
  
  //ctr_rot.vn=1;
  //ste.vn=1;
  cum[0]=cum[1]=0;
  wav_cnt[0]=wav_cnt[1]=0;
  cnt=0;
  fot=1;
  fva=1;
  status|=ANI_MOTION;
}

void aniHornet::scene(void) {
  
  int hum=this==aniMated::humanized;
  
  if (keyboard_down('h'))
    pos.in(0,glExp(tensor<double>::randn(1,3)).data,12);
  if (keyboard_down('u'))
    pos(2,3)+=1;
  
  // stabilization
  tensor<double> mtc=tensor<double>::vector(4).as( 0.0, 0.0, 10.0, 0.0);
  time tim=opengl_time;
  mtc(0)=perlin( tim.s());
  mtc(1)=perlin(-tim.s());
  mtc=mtc.normal();
  tor+=pos.solve(glMatchVectorsD(pos[2],mtc))*2-ome;
  
  tensor<double> rot[2];  
  if (hum) {
    ctr_bst[0].cn=keyboard(KEY_AU)-keyboard(KEY_AD);
    ctr_bst[1].cn=keyboard(KEY_AL)-keyboard(KEY_AR);
    ctr_fir.cn=keyboard(' ');
    ctr_fir.EXACT_integrate();    
    if (keyboard(' '))
      if (fir<opengl_time) {
        ++cnt;
        aniArmory::shot(pos*glT( 1.1,cnt%2? 0.8:-0.8, 1.3)*glExp(tensor<double>::vector(3).as( 0.0,random<double>::normal()*0.02,random<double>::normal()*0.02)),60);
        fir=opengl_time+(0.8-ctr_fir.vn*0.5);
        acc(0)-=10;
      }
  }    
  ctr_upd[0].cn=1;
  ctr_upd[1].cn=1;
  for (int c0=0;c0<2;++c0) {
    ctr_bst[c0].EXACT_integrate();
    ctr_upd[c0].EXACT_integrate();
  }
  
  //acc-=glI(pos)[2]*aniMated::gravity;
  tensor<double> upv=tensor<double>::vector(4).as( 0.0, 0.0, 1.0, 0.0);
  tensor<double> frc;
  for (int c0=0;c0<2;++c0) {
    //tmp=
    rot[c0]=glExp(tensor<double>::vector(4).as( 0.0, (ctr_bst[0].vn + ctr_bst[1].vn*(c0?-1:1))*0.6, 0.0, 0.0));
    frc=pos*rot[c0][2];
    frc(2)=0;
    frc=pos.solve(frc);
    //frc-=upv*(frc|upv);
    acc+=frc*max(0,6-3*ome.norm());
    tor+=lev_bst[c0].x(frc);
  }
  eng.vel=vel;
  eng.play();
  tensor<double> top=tensor<double>(1,4).as( 0.0, 0.0, 1.0, 0.0);
  // TODO bos.pn mod 2pi  
  for (int c0=0;c0<2;++c0) {
    rot[c0]=rot[c0]*glExp(tensor<double>::vector(4).as( 0.0, 0.0, (c0?-3:3)*ctr_upd[c0].pn, 0.0));
    app_bst[c0].trf=glT(dsp_bst[c0])*rot[c0];//*glExp(tensor<double>::vector(4).as( 0.0, 0.0, (c0?-5:5)*ctr_upd[c0].pn, 0.0));
  }
}

void aniHornet::hover(aniMated* ani) {
  ani->rap->pos=ani->pos;
  hul_rap->pos =pos;  
  if (rapid::collide(*hul_rap,*ani->rap)) {
    tensor<double> dnv=glI(pos)[2];
    dnv*=2-vel(2);    
    acc+=pos.solve(dnv);
  } else {
    tensor<double> dnv=glI(pos)[2];
    dnv*=min(max(-1,pos(2,3)-2),2)*-1;
    dnv*=2-vel(2);    
    acc+=pos.solve(dnv);
  }
}

void aniHornet::interact(aniWave* wav) {
  tensor<double> frm;
  tensor<double> vec=tensor<double>::vector(4); vec(3)=1;
  for (int c0=0;c0<2;++c0) {
    frm=pos*app_bst[c0].trf;    
    if (0.2<frm(2,2)) {
      double hgt=frm(2,3)/frm(2,2); // usually 0<hgt
      vec(2)=-hgt;
      cum[c0]+=aniMated::dt*max(0,10-hgt);
      if (1.0<cum[c0]) {
        ++wav_cnt[c0];
        int tmp=++wav->dsr;
        tmp%=wav->num;
        wav->let[tmp].particle(frm*vec,(wav_cnt[c0]%2?-1:1)*1.5);
        cum[c0]=0;
      }
    }
  }
}

