// code by jph

class aniMustang : public aniMated {
public:
  aniMustang(int num);
  ~aniMustang() {
    delete hlg[0];
    delete hlg[1];
  }
  void scene(void);
  void draw(void);
  char* toString(void) { return "aniMustang"; };
  opengl_light* hlg[2];
  
  double tmp;
  audio eng;  
};

aniMustang::aniMustang(int num) : 
  eng("get/mustang/idle.wav",FMOD_LOOP_NORMAL|FMOD_3D)
{
  char fnc[80];
  sprintf(fnc,"get/mustang/tex_%i.tex",num);
  msh=new meshgl(*opengl_meshgl("get/mustang/msh"));
  msh->texture=opengl_texture(fnc);
  shd=new shadow(opengl_meshgl("get/mustang/shd"));
  hlg[0]=new opengl_light();
  hlg[1]=new opengl_light();
  hlg[0]->lin=.15;
  hlg[1]->lin=.15;
  hlg[0]->qdr=.03;
  hlg[1]->qdr=.03;
  //hlg[0]->cut=50;
  //hlg[1]->cut=50;
  //hlg[0]->exp=20;
  //hlg[1]->exp=20;
  //hlg[0]->dif=opengl_color_gray70;
  hlg[0]->dif=tensor<double>::rand(1,4);
  hlg[1]->dif=tensor<double>::rand(1,4);
  hlg[0]->dif.data[3]=0;
  hlg[1]->dif.data[3]=0;
  hlg[0]->dif=hlg[0]->dif.normal();
  hlg[1]->dif=hlg[1]->dif.normal();
  //hlg[0]->dif=opengl_color_white;
  //hlg[1]->dif=opengl_color_white;
  //hlg[0]->shadow=1;
  tmp=max(0.3,random<double>::uniform());  
}

void aniMustang::scene(void) {
  // coordinates of corner are  2.0 0.95 0.19
  vel=pos[0];
  vel*=sin(opengl_time.s()*tmp)*.1;
  tensor<double> trl=tensor<double>::eye(4);
  //trl(0,3)= 2.1;
  //trl(1,3)= 0.95;
  //trl(2,3)= 0.19;
  trl(0,3)= 2.02;
  trl(1,3)= 0.80;
  trl(2,3)= 0.03;
  hlg[0]->pos=pos*trl;
  trl(1,3)=-0.80;
  hlg[1]->pos=pos*trl;
  
  eng.vol=0.2; // TODO sound design is missing !!!
  eng.pos=pos;
  eng.play();
  
  //uint myp;
  //FMOD_Channel_GetPosition(eng.channel,&myp,FMOD_TIMEUNIT_MS);
  //opengl_bulletin.add(tensor<int>::string( myp ));
  //hlg[0]->dir=pos*dir;
  //hlg[1]->dir=pos*dir;  
}

void aniMustang::draw(void) {  
  //assert(false);
  aniMated::draw();
  //glPopName();
  //tensor<double> vec(1,4);
  //vec.data[1]=MATH_PI_2;
  tensor<double> trf(2,4,4);
  trf.data[2]=-1;
  trf.data[5]=trf.data[8]=trf.data[15]=1;
  
  //printf("%s\n\n",trf.toString());
    trf(0,3)= 2.01;
    trf(1,3)= 0.80;
    trf(2,3)= 0.03;
  glColor4dv(opengl_color_white.data);
  glPushMatrix();
    glMultMatrixd(trf.data);
    glutSolidDisc( 0.09,12);
  glPopMatrix();
    trf(0,3)= 2.01;
    trf(1,3)=-0.80;
    trf(2,3)= 0.03;
  glPushMatrix();
    glMultMatrixd(trf.data);
    glutSolidDisc( 0.09,12);
  glPopMatrix();
}
