// code by jph

class aniTugboat : public aniMated {
public:
  aniTugboat();
  void scene(void);
  char* toString(void) { return "aniTugboat"; };
  
  tensor<double> lev;
  control<double> bos;
  control<double> ste;
  aniAppend app_rot;
  aniMated* fan;
  //meshgl msh_cut;
  audio eng;
  audio wav;
  double sub;
};

aniTugboat::aniTugboat() :
  eng("get/audio/boat.wav",FMOD_LOOP_NORMAL|FMOD_3D),
  wav("get/audio/aqua.wav",FMOD_LOOP_NORMAL|FMOD_3D) {

  msh=opengl_meshgl("get/mesh/tugboat"); //long_72_cnv
  
  double vol;
  tensor<double> ctr=msh->centroid(vol);
  printf("%s\n",ctr.toString());
  *msh=msh->map(glT(ctr*-1));  
  shd=new shadow(msh);
  ine=msh->inertia();
  rap=new rapid(msh);
  setMassByVolume(0.6);
  status|=ANI_MOTION;
  fva=1;
  fot=1;
  
  //printf("INERTIA\n%s\n",ine.toString());
  

  bos.MU=0.5;
  lev=tensor<double>::vector(4).as(-5.5, 0.0,-0.0, 1.0);
  sub=0;

  app_rot.mas=this;
  app_rot.slv=new aniMated();
  app_rot.slv->msh=opengl_meshgl("get/mesh/bpro");
  tensor<double> map=glExp(tensor<double>::vector(4).as( 0.0, 0.0, 0.0, 0.0));
  *app_rot.slv->msh=app_rot.slv->msh->map(map);
  app_rot.slv->shd=new shadow(app_rot.slv->msh);
  aniWorld::singleton()->link(&app_rot);
  aniWorld::singleton()->add(app_rot.slv);
  
}


void aniTugboat::scene(void) {  
  if (keyboard_down('r')) {
    pos(2,3)=7;
    rap->pos=pos;
  }
  acc-=glI(pos)[2]*aniMated::gravity;
  int hum=this==aniMated::humanized;  
  bos.cn=(keyboard(KEY_AU)-keyboard(KEY_AD))*hum*(2-(sub<0));
  ste.cn=(keyboard(KEY_AR)-keyboard(KEY_AL))*hum;
  control<double>::dt=opengl_rate.s();
  bos.EXACT_integrate();
  ste.EXACT_integrate();
  //if (sub<0) {
    tensor<double> frc=tensor<double>::vector(4).as(
      cos(ste.vn)*bos.vn*20*opengl_slider("dinghy accel",0.5),
      sin(ste.cn)*bos.vn*20*opengl_slider("dinghy rotation",0.3),
      0.0, 0.0);
    acc+=frc;
    tor+=lev.x(frc);
  //}
  eng.vol=0.5+0.3*abs(bos.vn);
  double bla=(vel+pos*ome.x(lev)).norm()*0.1;
  eng.doppler(1+abs(bos.vn)*bla);
  eng.pos=pos*lev;
  eng.vel=vel;
  eng.play();
  
  wav.vol=min(vel.norm()*0.1*(sub<0),1);
  wav.pos=pos[3];
  wav.play();
  //app_rot.trf=glT(lev)*glExp(tensor<double>::vector(4).as( bos.pn*10, 0.0, 0.0, 0.0));
  app_rot.trf=glT(lev)*glExp(tensor<double>::vector(4).as( bos.pn*10, 0.0, 0.0, 0.0));
}
