// code by jph

class aniTurret : public aniMated {
public:
  aniTurret(void);
  void scene(void);
  //void aim(aniMated* ani);
  int fire(void);
  char* toString(void) { return "aniTurret"; };
  aniAppend app_rot;
  tensor<double> lev_rot;
  control<double> ctr_rot;
  control<double> ctr_upd;
  control<double> ctr_fir;  
  audio eng;  
  time fir;
  int cnt;
  
  double  fir_buf; // timer
  int     fir_bst; // count down
  
  static double vn;
};

double aniTurret::vn=2e1;

aniTurret::aniTurret(void) : 
  eng("get/audio/turret_grind.aiff",FMOD_LOOP_NORMAL|FMOD_3D)
   {
  msh=opengl_meshgl("get/mesh/turret_stand");
  shd=new shadow(msh);
  rap=new rapid(msh);
  lev_rot=tensor<double>::vector(4).as( 0.73, 0.0, 0.98, 1.0);
  
  app_rot.mas=this;
  app_rot.slv=new aniMated();
  app_rot.slv->msh=opengl_meshgl("get/mesh/turret_gun");
  app_rot.slv->shd=new shadow(app_rot.slv->msh);
  //app_rot.slv->rap=new rapid(app_rot.slv->msh);
  aniWorld::singleton()->link(&app_rot);
  aniWorld::singleton()->add(app_rot.slv);  
  //ctr_upd.vn=1;
  //ste.vn=1;
  cnt=0;
  fot=1;
  fva=1;
  status|=ANI_MOTION;
  fir_bst=0;
}

void aniTurret::scene(void) {  
  int hum=this==aniMated::humanized;
  if (hum) {
    ctr_rot.cn=-mouse_drag(0)/dt;
    ctr_upd.cn= mouse_drag(1)/dt;    
  } else {
    ctr_rot.vd=0;
    ctr_rot.vn=ome(2);
    
    //tensor<double> dir=pos.solve(mouse_scene);//
    tensor<double> dir=pos.solve(aniMated::humanized->pos[3]);
    dir-=lev_rot;
    dir(2)-=0.3;
    ctr_rot.pn=0;
    ctr_rot.pd=atan2(dir(1),dir(0));
    ctr_rot.EXACT_VP();
    
    ctr_upd.pd=min(max(-0.7,atan2( dir(2),sqrt(dir(0)*dir(0)+dir(1)*dir(1)))),0.85);
    ctr_upd.EXACT_VP();
    //printf("%f\n",ctr_upd.pd);
    //ctr_rot.pn=ome(2);
    fir_buf+=(pos.solve(aniMated::humanized->pos[3]).norm()<80)*aniMated::dt;
    //opengl_bulletin.add(tensor<double>::string( fir_buf ));
    if (6<fir_buf) { // 6 seconds between bursts
      fir_bst=4;
      fir_buf=0;
    }
  }
  
  int bol=keyboard('.') || fir_bst;
  ctr_fir.cn=bol;
  ctr_fir.EXACT_integrate();
    
  if (bol && fire()) {
    fir_bst=max(0,fir_bst-1);
    fir_buf=0;
  }

  ctr_rot.EXACT_integrate();
  ctr_upd.EXACT_integrate();
  
  tor(2)=ctr_rot.cn;

  eng.pos=pos[3];
  eng.vel=0;
  eng.vol=min(ome.norm()+abs(ctr_upd.vn),1);
  eng.play();
  
  app_rot.trf=glT(lev_rot)*glExp(tensor<double>::vector(4).as( 0.0,-ctr_upd.pn, 0.0, 1.0));
}

int aniTurret::fire(void) {
  if (fir<opengl_time) {
    aniArmory::shot(pos*app_rot.trf*glT(3.4,0,0.3),100);
    fir=opengl_time+(0.6-ctr_fir.vn*0.5);
    return 1;
  }
  return 0;
}
