// code by jph

#ifndef TIMER_INCLUDED
#define TIMER_INCLUDED

class timer {
public:
  timer(void);
  void tic(void);
  double toc(void);
  time beg;
  time end;
  time sum;
  int cnt;
//----------------------------------------------------------------------
  static timer* tic(char* str);
  static void stats(void);
  static hash<tensor<char>,timer*> hash;
};

timer::timer(void) {
  cnt=0;
}

void timer::tic(void) {
  beg=time::now();
}

double timer::toc(void) {
  end=time::now();
  time dif(end-beg);
  sum+=dif;
  ++cnt;
  return dif.s();
}

timer* timer::tic(char* str) {
  tensor<char> key=tensor<char>::string(str);
  timer* ret;
  if (!hash.get(key,ret)) {
    ret=new timer();
    hash.add(key,ret);
  }
  ret->tic();
  return ret;
}

void timer::stats(void) {
  if (hash.numel) {
    tensor<tensor<char>> str=hash.keys();
    str=str(tensor_char_order(str));
    timer* ret;
    tensor<timer*> tmr(1,str.numel);
    tensor<double> tim(1,str.numel);
    int mxn=0;
    for (int c0=0;c0<str.numel;++c0) {
      mxn=max(mxn,str(c0).numel);
      hash.get(str(c0),ret);
      tmr(c0)=ret;
      tim(c0)=ret->sum.s();
    }
    char buf[100];
    sprintf(buf,"%%%is%%7.3f %%10.2e %%7.3f\n",mxn);
    double fac=100/tim.sum();
    printf("timer statistics:\n");
    for (int c0=0;c0<str.numel;++c0)
      printf(buf,(str(c0)&0).data,tim(c0),tim(c0)/tmr(c0)->cnt,tim(c0)*fac);  
  }
}

hash<tensor<char>,timer*> timer::hash(16);

#endif
