function gusland

grd=6;

A=double(imresize(imread('get/tensor/island.bmp'),[60 NaN]));
A=A/max(A(:));

size(A)
mesh(A);

F=fspecial('gaussian',[2 2],1);
B=convn(A,F,'same');

B=(B-0.15)*40;
f=find(6<B);
R=convn(randn(size(B)),fspecial('gaussian',[2 2],1),'same');
B(f)=B(f)+R(f);

[X,Y]=meshgrid(0:size(B,2)-1,0:size(B,1)-1);

model.file='canyon';
model.auto=1;
model.texture=[
reshape(Y,[1 numel(Y)])
reshape(X,[1 numel(X)])
]*0.1;
model.vert=[
  reshape(Y,[1 numel(Y)])*grd
  reshape(X,[1 numel(X)])*grd
  reshape(B,[1 numel(B)])
];

num=size(model.vert,2);

model.color=[
  model.vert
  ones(1,num)
];

[BX,BY]=gradient(B,1);

grad.dx=[
  repmat(1,[1 numel(X)])*grd
  repmat(0,[1 numel(X)])*grd
  reshape(BX,[1 numel(B)])
];
grad.dy=[
  repmat(0,[1 numel(X)])*grd
  repmat(1,[1 numel(X)])*grd
  reshape(BY,[1 numel(B)])
];


for c1=1:num
  hgt=model.vert(3,c1);
  %if 4<hgt
    nrm=cross(grad.dx(:,c1),grad.dy(:,c1));
    nrm=nrm/norm(nrm);
    nrm;
    if 0.8<nrm(3)
      gre=[86 106 28].*(rand(1,3)*0.5+0.5);
      model.color(:,c1)=jicolor(gre/106*255);
    else
      gre=[86 100 86].*(rand(1,3)*0.2+0.8);
      model.color(:,c1)=jicolor(gre/106*255);
      %model.color(:,c1)=jicolor([23 25 40]);
    end
  %under water default
  if hgt<0
    model.color(:,c1)=jicolor([178 106 38]/178*255);
  end
  % beach
  if -4<hgt & hgt<4 & 0.80<nrm(3)
    model.color(:,c1)=jicolor([178 178 2]/178*255);
  end
end

Q={};

wid=size(B,1);
for cy=0:size(B,2)-2
for cx=1:wid-1
  ofs=cy*wid+cx;
  Q=vertcat(Q,[ofs+wid ofs ofs+1 ofs+wid+1 ]);
end
end

model.quad=cell2mat(Q)';

figure(1)
clf reset
xTQmesh(model)
view(0,90)
hold on
%plot3(pln(1,:),pln(2,:),pln(3,:),'r*')
model=xTQnormal(model);
model.dir='get/mesh/';
xTQsave(model)
disp(xsave(B,'float',[model.dir 'canyon_height.arr']))
%figure(3)
%imagesc(B)
%disp(xsave(pln,'double',[model.dir 'canyon_palms.arr']))
%min(B(:))

%return

figure(2)
clf reset
[c,h]=contour(B,[0 0]);
clf reset

col={'b','r','g','k','b:','r:','g:','k:','y','y:'};

f=find(c(1,:)==0);
cnt=1;

edge=[];
for c1=f
  ind=c1+1:c1+c(2,c1);
  crv=c(:,[ind ind(2)]);
  ang=size(crv,2)-2; % wtf
  for c2=2:size(crv,2)-1
    v1=crv(:,c2)-crv(:,c2-1);
    v2=crv(:,c2+1)-crv(:,c2);
    z1=v1(1)+v1(2)*i;
    z2=v2(1)+v2(2)*i;
    ang(c2-1)=angle(z2/z1);
  end
  [mx,mi]=max(abs(ang)); mi=mi+1;
  %plot(c(1,ind),c(2,ind),'o')
  %hold on
  ind=ind([mi:end-1 1:mi-1]); % Ok !?
  lop=c(:,ind);
  %plot(lop(1,:),lop(2,:),'b')
  %hold on
  lop=jireduce(lop);
  lop=fliplr(flipud(lop));
  edge=[ edge [lop;lop(:,[2:end 1])] ];
  plot(lop(1,[1:end 1]),lop(2,[1:end 1]),'-k')
  hold on
  cnt=cnt+1;
end
%plot(pln(1,:),pln(2,:),'r*')

axis equal


disp(xsave((edge-1)*grd,'double',[model.dir 'canyon_edges.arr']))
axis([0 size(A,1) 0 size(A,2)])

function crv=jireduce(crv)

flag=1;
while flag
  flag=0;
  ang=zeros(1,size(crv,2)-2); % wtf
  for c2=2:size(crv,2)-1
    v1=crv(:,c2)-crv(:,c2-1);
    v2=crv(:,c2+1)-crv(:,c2);
    z1=v1(1)+v1(2)*i;
    z2=v2(1)+v2(2)*i;
    ang(c2-1)=angle(z2/z1);
  end
  [mn,mi]=min(abs(ang)); mi=mi+1;    
  %[mi size(crv,2)]
  if mn<0.3 & 2<size(crv,2)
    crv=crv(:,[1:mi-1 mi+1:end]);
    
    flag=1;
  end
end


function col=jicolor(col)
  col=col/255+randn(1,3)*0.07;
  col=min(max(0,col),1);  
  col=[col 1]';
