function res=perlin_test(dim)

switch dim

case 2

  [x,y]=meshgrid(linspace(20,21,200));
  
  z=x;
  
  for c1=1:numel(x)
    z(c1)=perlin([x(c1) y(c1)])/2;
    for c2=[2 4 8 16]
      z(c1)=z(c1)+perlin(c2*[x(c1) y(c1)])/c2/2;
    end
  end
  [min(z(:)) max(z(:))]
  
  subplot(1,2,1)
  imshow(uint8((z+1)*128))
  subplot(1,2,2)
  mesh(z)

case 3

  for t=linspace(0,1,25);
    [x,y,z]=sphere(250);
  
    for c1=1:numel(x)
    
      p1=(perlin([x(c1) y(c1) z(c1)   t]));
      p2=(perlin(10.6*[x(c1) y(c1) z(c1) t]));
      p3=(perlin((y(c1)*y(c1)*5)*[x(c1) y(c1) z(c1) t]));
      p4=(perlin((x(c1)>0)*0.1*[x(c1) y(c1) z(c1) t]));
      
      x(c1)=x(c1)*(6000+8*(p1*4+p2+p3*0.5+p4*5));
      y(c1)=y(c1)*(6000+8*(p1*4+p2+p3*0.5+p4*5));
      z(c1)=z(c1)*(6000+8*(p1*4+p2+p3*0.5+p4*5));
    
    end
    
    c=(x.*x+y.*y+z.*z);
    c=c-min(c(:));
    c=c/max(c(:));
    warp(-x,y,z,c)
    %axis([-20 20 -20 20 -20 20])
    pause(0.3)
    break
  end

case 4

  num=25;
  [x,y,z]=meshgrid(linspace(0,1,num));

  p=x*0;  
  
  for c1=1:numel(x)
    p(c1)=perlin([4+x(c1) 20+y(c1) 10+z(c1)]);
  end
  
  [mx,mi]=max(p(:));
  
  [i1,i2,i3]=ind2sub(size(p),mi);
  ind=[i1 i2 i3];
  if ~(all(1<ind) & all(ind<num))
    disp('BOUNDARY ERROR')
    ind
  end
  if (i3-1)*num*num+(i2-1)*num+i1 ~= mi
    disp('ERROR')
  end
  

end

