// code by jph

#define _CRT_SECURE_NO_DEPRECATE  // no warnings when using std::c in vcpp compiler 14
// #define NDEBUG
#define TENSOR_SVD_NDEBUG

#define GLEW_INCLUDE

#include "../_util/_opengl.hpp"
#include "../_util/audio.hpp"
#include "../_extern/pthread.h"
#include "../_animated/_animated.hpp"

aniAvatar*            ava;
//aniCamera*            cam;
aniWave*              wav;
aniBoat*              din;
aniTugboat*           tug;
aniCatamaran*         cat;
aniApache*            apa;
aniHornet*            hor;
aniTurret*            tur;
aniForest*            fst=0;

opengl_light*         light;

double camera_ang=-MATH_PI_2*0.4;
double camera_hgt=13;
rapid_touch tch;
tensor<double> bnd;

meshgl* sky=opengl_meshgl("get/mesh/sky_138_tnv");


// TODO draw mesh upside down when underwater
// TODO sphere map !!!

void configuration(int type) { // defines body and collision characteristics

  SYSTEM_INFO system_info;
  GetSystemInfo(&system_info);
  printf("NumberOfProcessors: %i\n",system_info.dwNumberOfProcessors);
  tensor<double> map=glT(tensor<double>::vector(3).as( 400.0, 400.0, 0.0)); // HAS TO HAVE INTEGER VALUES!

  meshgl* gnd=opengl_meshgl("get/mesh/canyon_tcnv");
  gnd->texture=opengl_texture("get/tensor/gravel.bmp");
  fst=new aniForest(gnd);
  fst->tre<<=new aniTree("get/tensor/barkpine.bmp",3.0,20.0);
  fst->tre<<=new aniTree("get/tensor/palmpine.bmp",1.2, 8.0);
  fst->tre<<=new aniTree("get/tensor/realpalm.bmp",2.0,12.0);
  tensor<float> hgt("get/mesh/canyon_height.arr");
  //fst->trees(hgt,5);
  if (1) {
    fst->grass("get/tensor/grass.bmp");
    fst->grs<<=new aniGrass( 1.0, 1.5,tensor<double>::vector(4).as( 0.50, 1.00, 0.5, 0.875));
    fst->grs<<=new aniGrass( 0.9, 2.0,tensor<double>::vector(4).as( 0.08, 0.42, 0.5, 1.00));
    fst->grs<<=new aniGrass( 1.0, 1.6,tensor<double>::vector(4).as( 0.00, 0.5 , 0.0, (512-311)/512.0));
    fst->grass(hgt,12);
  }
  fst->pos=map*fst->pos;
  //fst->shd=new shadow(gnd);
  aniWorld::singleton()->add(fst);  
  bnd=map*fst->msh->bounding();
  //printf("%s\n",bnd.toString());
  
  aniMated* ani;
  rapid* rap;
  shadow* shd;
  ani=new aniMated();
  ani->pos=glT(443.4,496.5,6.3+3.7)*glExp(tensor<double>::vector(4).as( 0.0, 0.0,-1.0, 0.0));
  ani->msh=opengl_meshgl("get/mesh/moai");
  shd=new shadow(ani->msh);
  rap=new rapid(ani->msh);
  ani->shd=shd;
  ani->rap=rap;
  aniWorld::singleton()->add(ani);
  
  ani=new aniMated();
  ani->pos=glT(561.7,613.8,5.75+3.7)*glExp(tensor<double>::vector(4).as( 0.0, 0.0,-2.0, 0.0));
  ani->msh=opengl_meshgl("get/mesh/moai");
  ani->shd=shd;
  ani->rap=rap;
  aniWorld::singleton()->add(ani);

  ani=new aniMated();
  ani->pos=glT(541.0,503.0,5.67+2.4)*glExp(tensor<double>::vector(4).as( 0.0, 0.0, 0.0, 0.0));
  ani->msh=opengl_meshgl("get/mesh/obelisk");
  rap=new rapid(ani->msh);
  shd=new shadow(ani->msh);
  ani->shd=shd;
  ani->rap=rap;
  aniWorld::singleton()->add(ani);

  ani=new aniMated();
  ani->pos=glT(543.0,479.0,6.48+2.4)*glExp(tensor<double>::vector(4).as( 0.0, 0.0, 0.0, 0.0));
  ani->msh=opengl_meshgl("get/mesh/obelisk");
  ani->shd=shd;
  ani->rap=rap;
  aniWorld::singleton()->add(ani);
  
  //ani=new aniMated();
  //ani->pos=glT(574.0,520.0,9.66+2.4)*glExp(tensor<double>::vector(4).as( 0.0, 0.0, 0.0, 0.0));
  //ani->msh=opengl_meshgl("get/mesh/obelisk");
  //ani->shd=shd;
  //ani->rap=rap;
  //aniWorld::singleton()->add(ani);
  
  ani=new aniMated();
  ani->pos=glT(596.0,499.0,7.5+2.4)*glExp(tensor<double>::vector(4).as( 0.0, 0.0, 0.0, 0.0));
  ani->msh=opengl_meshgl("get/mesh/obelisk");
  ani->shd=shd;
  ani->rap=rap;
  aniWorld::singleton()->add(ani);
  
  ani=new aniMated();
  ani->pos=glT(481,638,6.1)*glExp(tensor<double>::vector(4).as( 0.0, 0.0,-2.0, 0.0));
  ani->msh=opengl_meshgl("get/mesh/arch");
  ani->shd=new shadow(ani->msh);
  ani->rap=new rapid(ani->msh);
  aniWorld::singleton()->add(ani);

  ani=new aniMated();
  ani->pos=glT(656.5,558,4.0)*glExp(tensor<double>::vector(4).as( 0.0, 0.0,-0.3, 0.0));
  ani->msh=opengl_meshgl("get/mesh/bridge");
  ani->shd=new shadow(ani->msh);
  ani->rap=new rapid(ani->msh);
  aniWorld::singleton()->add(ani);

  
  din=new aniBoat();
  din->pos=map*glExp(tensor<double>::vector(3).as( 0.0, 0.0, 1.3));
  din->pos(2,3)-=0.3;
  aniWorld::singleton()->add(din);
  
  tug=new aniTugboat();
  tug->pos=glT(391,443,0.0)*glExp(tensor<double>::randn(1,3)*0.0);
  aniWorld::singleton()->add(tug);
  
  //for (int c0=0;c0<10;++c0) {    
    cat=new aniCatamaran();
    //cat->pos=glT(383,484,0.0)*glExp(tensor<double>::randn(1,3)*0.0);
    cat->pos=glT(498,483,0.0)*glExp(tensor<double>::randn(1,3)*0.0);
    aniWorld::singleton()->add(cat);
  //}
  
  wav=new aniWave(system_info.dwNumberOfProcessors,60,50,1e3,1e3);
  //wav=new aniWave(50,60,50,1e3,1e3);
  wav->setSpeed(6);
  wav->pos=map;
  tensor<double> edg("get/mesh/canyon_edges.arr");
  wav->edges(edg);
  wav->texture_wav=opengl_texture("get/tensor/water.bmp");
  wav->texture_ref=opengl_texture("get/tensor/cloudrefs.bmp");
  aniWorld::singleton()->add(wav);
  
  apa=new aniApache();
  //apa->pos=glT(417,556,20)*glExp(tensor<double>::randn(1,3)*0.2);
  apa->pos=glT(470,551,10)*glExp(tensor<double>::randn(1,3)*0.2);
  //apa->pos=glT(391,443,1.2);
  aniWorld::singleton()->add(apa);
  
  hor=new aniHornet();
  hor->pos=glT(405,467,3)*glExp(tensor<double>::randn(1,3)*0.2);
  aniWorld::singleton()->add(hor);
  
  tur=new aniTurret();
  tur->pos=glT( 460.6, 416.4, 2.73);
  aniWorld::singleton()->add(tur);
  
  tur=new aniTurret();
  tur->pos=glT( 629.6, 512.1, 1.6);
  aniWorld::singleton()->add(tur);
  
  //cam=new aniCamera();
  //cam->focus(din,tensor<double>(1,4).as(-10.0, 0.0, 5.0, 1.0));
  //aniWorld::singleton()->add(cam);
  
  sky->texture=opengl_texture("get/tensor/sky_day.bmp");
  
  aniMated::humanized=cat;
}

linked<int> testprt[4];

int main(int argc,char** argv) {  
  opengl_recording_numel=600;
  opengl_recording_frame=1;     // take shot every x frames
  opengl_size.as(800,600);
  opengl_position.as(70,5);
  opengl_title=tensor<char>::string("Version 1.0 (without shaders)");
  
  audio::main();
  
  opengl_ambience=opengl_color_gray30;
  
  opengl_main(argc,argv);
  
  glFogi(GL_FOG_MODE, GL_EXP); // GL_LINEAR, GL_EXP2 Fog Mode
  glFogfv(GL_FOG_COLOR, opengl_color_blue.to<float>().data); // Set Fog Color
  glFogf(GL_FOG_DENSITY, 0.01f); // How Dense Will The Fog Be
  glHint(GL_FOG_HINT, GL_NICEST); // Fog Hint Value
  glFogf(GL_FOG_START, 1.0f); // Fog Start Depth
  glFogf(GL_FOG_END, 100.0f); // Fog End Depth
  glEnable(GL_FOG);
  
  ava=new aniAvatar();
  ava->pos(2,3)=3;
  ava->fva=tensor<double>(1,4).as( 0.3, 0.3, 0.3, 0.0);
  ava->fot=tensor<double>(1,4).as( 0.3, 0.3, 0.3, 0.0);
  aniWorld::singleton()->add(ava);
  
  light=new opengl_light();
  light->dif=tensor<double>(1,4).as( 0.7, 0.7, 0.7, 0.0); // TODO try without a=1.0

	configuration(0);
	
	tensor<double> lod("get/tensor/avatar.pos");
  if (lod.data)
    ava->pos=lod;
  glutMainLoop();
  return 0;
}

meshgl  msh_cut;
linked<tensor<double>> msh_deb;

void scene(void) {
  int c0,c1,c2;
  aniMated* ani;
  aniMated::dt=opengl_rate.s();
  if (ANI_DT_MAX<aniMated::dt) {
    aniMated::dt=ANI_DT_MAX;
    opengl_bulletin.add(tensor<char>::string( "low framerate" )); 
  }
  control<double>::dt=aniMated::dt;
  
  double tim=opengl_slider("light direction",0.1)*MATH_2PI;//opengl_time.s()*0.2;//0.02;
  tensor<double> mea=bnd.mean();
  tensor<double> dif=bnd.diff(1).flatten()*0.5;
  //printf("%s\n",mea.toString());
  light->pos(0,3)=mea(0)-cos(tim)*dif(0);
  light->pos(1,3)=mea(1)-sin(tim)*dif(1);
  light->pos(2,3)=200;

  
  //wav->setSpeed(10*opengl_slider("wave->set_speed",0.6));
    
  if (keyboard_down('1'))
    aniMated::humanized=ava;
  if (keyboard_down('2'))
    aniMated::humanized=tug;
  if (keyboard_down('3'))
    aniMated::humanized=apa;
  if (keyboard_down('4'))
    aniMated::humanized=hor;
  if (keyboard_down('5'))
    aniMated::humanized=tur;
  if (keyboard_down('6'))
    aniMated::humanized=cat;
  //if (keyboard_down('9'))
  //  aniMated::humanized=wav;
    
  aniWorld::singleton()->relax(); // acc=tor=0; deletes objects
  
  //if (fst) {
  //  aniMated::collide(fst,din);
  //  aniMated::collide(fst,cam);
  //  aniMated::collide(fst,apa);
  //}
  

  //din->sub=wav->submerge(din->pos*din->lev);
  din->vel=0;

  aniWorld::singleton()->scene();
  aniWorld::singleton()->collide();
  

  //printf("%s\n",din->pos.toString());
  // TODO manage by aniWorld
  timer* tmr;
  tmr=timer::tic("update");
  wav->update();
  tmr->toc();
  tmr=timer::tic("interact");
  linked<aniMated*>* mov=aniWorld::singleton()->private_mov();  
  while (mov->token(ani)) {
    if (aniMated::humanized==ani)
      wav->interact(ani,&msh_cut,&msh_deb);
    else
      wav->interact(ani,0,0); // wave patterns created by moving objects
    //opengl_bulletin.add( tensor<char>::string(ani->toString()) );
  }
  tmr->toc();
  //printf("%d %s\n",ani,ani->toString());
  //printf("\n\n");
  //wav->buoyancyT(ani);
  
  apa->interact(wav); // wave patterns caused by propeller
  hor->interact(wav); // wave patterns caused by propeller
  hor->hover(fst);
  
  if (opengl_pointing && mouse_button_down(0)) {
    int tmp=++wav->dsr;
    tmp%=wav->num;
    wav->let[tmp].particle(mouse_scene,tensor<double>::randn(1,3),random<double>::signum()*(1+random<double>::uniform()));
  }
  
  //float vol=0;
  ////FMOD_SoundGroup_GetVolume(audio::master,&vol);
  //FMOD_SoundGroup_SetVolume(audio::master,opengl_slider("audio volume",vol));

  aniWorld::singleton()->motion();
  
  if (keyboard_down('d'))
    wav->status^=ANI_DEBUG;

  if (keyboard_down('z')) {
    ava->pos=tensor<double>::eye(4);
    //ava->pos(0,3)=0;
    //ava->pos(1,3)=0;
  }

  double fq=1,ra=5;
  //light_top->pos=glT(din->pos[3])*glT(tensor<double>(1,4).as(-5.0, 5.0, 5.0, 0.0));

  ani=aniMated::humanized;
  if (ani==din||ani==apa||ani==hor||ani==tug||ani==cat) {
    tensor<double> lev=tensor<double>(1,4).as( 0.0,-50.0,camera_hgt, 0.0);
    lev*=opengl_slider("camera distance",0.55);
    tensor<double> ups=tensor<double>::vector(4).as(0.0,0.0,lev.norm()*0.1,0.0);
    lev(3)=1;
    tensor<double> flt=ani->pos[3];
    if (ani==tug||ani==din)
      flt(2)=0;
    ava->pos=glLookAt(glT(flt)*glD(tensor<double>(1,4).as( 0.0, 0.0, camera_ang, 0.0)).exp()*lev,flt+ups);
    camera_ang+=mouse_drag(0)*2;
    camera_hgt+=mouse_drag(1)*20;    
  } 
  if (ani==tur) {
    tensor<double> frm=tur->app_rot.slv->pos;    
    ava->pos=glLookAt(frm*tensor<double>::vector(4).as(-3.0, 0.0, 0.7, 1.0),frm*tensor<double>::vector(4).as( 0.0, 0.0, 0.7, 1.0));
  }
  if (ani==apa) {
    //opengl_camera
  }
  opengl_camera=ava->pos;
  if (wav->submerge(opengl_camera[3])<0) {
    glFogfv(GL_FOG_COLOR, opengl_color_blue.to<float>().data); // Set Fog Color
    glEnable(GL_FOG);
  } else 
    glDisable(GL_FOG);
  audio::listen(opengl_camera,tensor<double>(1,4));  
  opengl_camera=glI(opengl_camera); // TODO odd !!!
  //opengl_camera=cam->opengl();
}

void display(void) {
  aniWorld::singleton()->display();
}

void shadowing(opengl_light* lgt) {
  aniWorld::singleton()->shadow(lgt);
}

void finish(void) {
  timer* tmr=timer::tic("finish");
  tensor<double> mat;
  glPushAttrib(GL_ENABLE_BIT);
    glDisable(GL_LIGHTING);
    glPushMatrix();
      mat=tensor<double>::eye(4);
      mat(2,3)=-0.12;
      mat(3,3)=1e-4;
      glMultMatrixd(mat.data);
      sky->draw();
    glPopMatrix();
    //fst->draw_std();
    fst->grass();
    
    glPushAttrib(GL_ENABLE_BIT);
      glEnable(GL_BLEND);
      glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
      aniWorld::singleton()->blend();
    glPopAttrib();
      //glPushMatrix();      
      //  glMultMatrixd(hor->pos.data);
      //  hor->hul_msh->color(3)=0.2;
      //  hor->hul_msh->draw();
      //glPopMatrix();
    if (wav->status&ANI_DEBUG) {
      glDisable(GL_DEPTH_TEST);
      for (int c0=2;c0<msh_cut.arr.numel;c0+=msh_cut.arr.size[0]) {
        msh_cut.arr.data[c0+0]=1;
        msh_cut.arr.data[c0+1]=1;
        msh_cut.arr.data[c0+2]=1;
        msh_cut.arr.data[c0+3]=0.5;
      }
      glEnable(GL_CULL_FACE);
      msh_cut.draw();
      double vol;
      mat=msh_cut.centroid(vol);
      assert(0<=vol);
      glPushMatrix();
        glMultMatrixd(glT(mat).data);
        glColor3d(0,0,1);
        glutSolidSphere(vol*1e-2,10,10);
      glPopMatrix();
      //tensor<double> v0(1,4);
      //tensor<double> v1(1,4);
      //int v3f=msh_cut.offsetV3F();
      glColor3d(1,0.2,0.2);
      for (int c0=0;c0<msh_cut.ind[MESH_EDGE].numel;c0+=2) {
        int e0=msh_cut.ind[MESH_EDGE].data[c0+0];
        int e1=msh_cut.ind[MESH_EDGE].data[c0+1];
        glPushMatrix();
          mat=glMatrixFromVector(msh_cut.point(e1)-msh_cut.point(e0),msh_cut.point(e0));
          vol=(msh_cut.point(e1)-msh_cut.point(e0)).norm();
          //printf("%s\n",mat.toString());
          glMultMatrixd(mat.data);
          glutSolidCone(vol*0.1,vol,10,3);
        glPopMatrix();
      }
      //printf("%s\n",msh_cut.toInfo());
      
      glColor3d(1,1,1);
      linked<aniMated*>* mov=aniWorld::singleton()->private_mov();  
      aniMated* ani;
      while (mov->token(ani)) {
        if (ani->msh) {
          //mat=ani->msh->centroid(vol);
          mat=tensor<double>::eye(4)[3];
          glPushMatrix();
            glMultMatrixd(glT(ani->pos*mat).data);
            glutWireSphere(0.1,5,5);
          glPopMatrix();
        }
      }
      wav->draw_dyn();
    }
  glPopAttrib();
  wav->blit(aniMated::humanized->pos[3]);
  // TODO friction on objects in flat water
  tmr->toc();
}

void shutdown(void) {
  timer::stats();
  printf("avg fps\t%7.3f\n",opengl_frame/opengl_time.s());
  exit(0);
}
